---
title: Using the User Timing API
slug: Web/API/User_Timing_API/Using_the_User_Timing_API
tags:
  - Guide
  - Web Performance
---
<div>{{DefaultAPISidebar("User Timing API")}}</div>

<p>The <strong><code>User Timing</code></strong> interface allows the developer to create application specific {{domxref("DOMHighResTimeStamp","timestamps")}} that are part of the browser's <em>performance timeline</em>. There are two types of <em>user</em> defined timing entry types: the "<code>mark</code>" {{domxref("PerformanceEntry.entryType","entry type")}} and the "<code>measure</code>" {{domxref("PerformanceEntry.entryType","entry type")}}.</p>

<p><code><strong>mark</strong></code> events are <em>named</em> by the application and can be set at any location in an application. <code><strong>measure</strong></code> events are also <em>named</em> by the application but they are placed between two marks thus they are effectively a <em>midpoint</em> between two marks.</p>

<p>This document shows how to create <code>mark</code> and <code>measure</code> {{domxref("PerformanceEntry.entryType","performance entry types")}} and how to use <code>User Timing</code> methods (which are extensions of the {{domxref("Performance")}} interface) to retrieve and remove entries from the browser's <em>performance timeline</em>.</p>

<p>A <em>live</em> version of the examples is available on <a href="https://mdn.github.io/dom-examples/performance-apis/Using_the_User_Timing_API.html">Github</a>, as is the <a href="https://github.com/mdn/dom-examples/blob/master/performance-apis/Using_the_User_Timing_API.html">source code</a>. Pull requests, enhancement requests and <a href="https://github.com/mdn/dom-examples/issues">bug reports</a> are welcome.</p>

<h2 id="Performance_marks">Performance <code>marks</code></h2>

<p>A performance <code><strong>mark</strong></code> is a <em>named</em> {{domxref("PerformanceEntry","performance entry")}} that is created by the application at some location in an application. The mark is a {{domxref("DOMHighResTimeStamp","timestamp")}} in the browser's <em>performance timeline</em>.</p>

<h3 id="Creating_a_performance_mark">Creating a performance <code>mark</code></h3>

<p>The {{domxref("Performance.mark","performance.mark()")}} method is used to create a performance mark. The method takes one argument, the <em>name</em> of the mark, as shown in the following example.</p>

<pre class="brush: js highlight:[8]">function create_marks(ev) {
  if (performance.mark === undefined) {
    log("Create Marks: performance.mark Not supported", 0);
    return;
  } else {
  log("Create marks", 0);
  // Create several performance marks including two with the same name
  performance.mark("mark-1");
  do_work(50000);
  performance.mark("mark-2");
  do_work(50000);
  performance.mark("mark-2");
  var marks = ["mark-1", "mark-2", "mark-2"];
  for (var i=0; i &lt; marks.length; i++)
    log("... Created mark = " + marks[i], 0);
}
</pre>

<h3 id="Retrieving_performance_marks">Retrieving performance <code>marks</code></h3>

<p>The {{domxref("Performance")}} interface has three methods to retrieve marks. The following examples shows how to use each of these methods ({{domxref("Performance.getEntries","performance.getEntries()")}}, {{domxref("Performance.getEntriesByType","performance.getEntriesByType(entryType)")}}, and {{domxref("Performance.getEntriesByName","performance.getEntriesByName(name, entryType)")}} ) to retrieve one or more marks.</p>

<pre class="brush: js highlight:[9,19,26]">function display_marks(ev) {
  if (performance.getEntries === undefined) {
    log("Display Marks: performance.getEntries Not supported", 0);
    return;
  }
  log("Display marks", 0);

  // Display each mark using getEntries()
  var entries = performance.getEntries();
  var j=0;
  for (var i=0; i &lt; entries.length; i++) {
    if (entries[i].entryType == "mark") {
      if (j == 0) { log("= getEntries()", 0); j++ }
      log("... [" + i + "] = " + entries[i].name, 0);
    }
  }

  // Display each mark using getEntriesByType()
  entries = performance.getEntriesByType("mark");
  for (var i=0; i &lt; entries.length; i++) {
    if (i == 0) log("= getEntriesByType('mark')", 0);
    log("... [" + i + "] = " + entries[i].name, 0);
  }

  // Display each mark using getEntriesName(); must look for each mark separately
  entries = performance.getEntriesByName("mark-1","mark");
  for (var i=0; i &lt; entries.length; i++) {
    if (i == 0) log("= getEntriesByName('mark-1', 'mark')", 0);
    log("... " + entries[i].name, 0);
  }
  entries = performance.getEntriesByName("mark-2","mark");
  for (var i=0; i &lt; entries.length; i++) {
    if (i == 0) log("= getEntriesByName('mark-2', 'mark')", 0);
    log("... " + entries[i].name, 0);
  }
}
</pre>

<h3 id="Removing_performance_marks">Removing performance <code>marks</code></h3>

<p>The {{domxref("Performance.clearMarks","performance.clearMarks()")}} method is used to remove one or more marks from the browser's performance timeline. If a specific mark <em>name</em> is given to this method, only the mark(s) with that name will be removed. However, if no argument is given, then all {{domxref("PerformanceEntry","performance entries")}} of type "<code>mark</code>" will be removed from the performance timeline. The following example demostrates both uses of this method.</p>

<pre class="brush: js highlight:[10,14]">function clear_marks(obj) {
  if (performance.clearMarks === undefined) {
    log("Clear Marks: performance.clearMarks Not supported", 0);
    return;
  }
  log("Clear marks", 0);

  if (typeof obj == "string") {
    log("... cleared '" + obj + "' mark(s)", 0);
    performance.clearMarks(obj);
  } else {
    // No argument specified so clear all marks
    log("... cleared All marks", 0);
    performance.clearMarks();
  }
}
</pre>

<h2 id="Performance_measures">Performance <code>measures</code></h2>

<p>A <code><strong>measure</strong></code> performance entry type is <em>named</em> by the application and its {{domxref("DOMHighResTimeStamp","timestamp")}} is placed between two <em>named</em> marks thus a measure is effectively a <em>midpoint</em> between two marks in the browser's performance timeline.</p>

<h3 id="Creating_a_performance_measure">Creating a performance <code>measure</code></h3>

<p>A <code>measure</code> is created by calling <code>performance.measure(measureName, startMarkName, endMarkName)</code> where <code>measureName</code> is the measure's name and <code>startMarkName</code> and <code>endMarkName</code> are the start and end names, respectively, of the marks the measure will be placed between (in the performance timeline).</p>

<pre class="brush: js highlight:[18]">function create_measures(ev) {
  if (performance.measure === undefined) {
    log("Create Measures: performance.measure Not supported", 1);
    return;
  }
  log("Create measures", 1);

  // Create several performance marks
  performance.mark("mark-A");
  do_work(50000);
  performance.mark("mark-B");

  performance.mark("mark-C");
  do_work(50000);
  performance.mark("mark-D");

  // Create some measures
  performance.measure("measure-1", "mark-A", "mark-B");
  performance.measure("measure-2", "mark-C", "mark-D");

  // Log the marks and measures
  var marks = ["mark-A", "mark-B", "mark-C", "mark-D"];
  for (var i=0; i &lt; marks.length; i++)
    log("... Created mark = " + marks[i], 1);
  var measures = ["measures-1", "measures-2"];
  for (var i=0; i &lt; measures.length; i++)
    log("... Created measure = " + measures[i], 1);

}
</pre>

<h3 id="Retrieving_performance_measures">Retrieving performance <code>measures</code></h3>

<p>The {{domxref("Performance")}} interface has three methods to retrieve measures. The following examples shows how to use each of these methods ({{domxref("Performance.getEntries","performance.getEntries()")}}, {{domxref("Performance.getEntriesByType","performance.getEntriesByType(entryType)")}}, and {{domxref("Performance.getEntriesByName","performance.getEntriesByName(name, entryType)")}}) to retrieve one or more measures.</p>

<pre class="brush: js highlight:[9,19,26]">function display_measures(ev) {
  if (performance.getEntries === undefined) {
    log("Display Measures: performance.getEntries Not supported", 1);
    return;
  }
  log("Display measures", 1);

  // Display each measure using getEntries()
  var entries = performance.getEntries();
  var j=0;
  for (var i=0; i &lt; entries.length; i++) {
    if (entries[i].entryType == "measure") {
      if (j == 0) { log("= getEntries()", 1); j++ }
      log("... [" + i + "] = " + entries[i].name, 1);
    }
  }

  // Display each measure using getEntriesByType
  entries = performance.getEntriesByType("measure");
  for (var i=0; i &lt; entries.length; i++) {
    if (i == 0) log("= getEntriesByType('measure')", 1);
    log("... [" + i + "] = " + entries[i].name, 1);
  }

  // Display each measure using getEntriesName() - have to look for each measure separately
  entries = performance.getEntriesByName("measure-1","measure");
  for (var i=0; i &lt; entries.length; i++) {
    if (i == 0) log("= getEntriesByName('measure-1', 'measure')", 1);
    log("... " + entries[i].name, 1);
  }
  entries = performance.getEntriesByName("measure-2","measure");
  for (var i=0; i &lt; entries.length; i++) {
    if (i == 0) log("= getEntriesByName('measure-2', 'measure')", 1);
    log("... " + entries[i].name, 1);
  }
}
</pre>

<h3 id="Removing_performance_measures">Removing performance <code>measures</code></h3>

<p>The {{domxref("Performance.clearMeasures","performance.clearMeasures()")}} method is used to remove <em>measures</em> from the browser's performance timeline. If the method is called with a specific measure name, all measures with that name will be removed from the timeline. If the method is called with no arguments, all {{domxref("PerformanceEntry","performance entries")}} with a type of "<code>measure</code>" will be removed from the timeline. The following examples shows both uses of this method.</p>

<pre class="brush: js highlight:[10,14]">function clear_measures(obj) {
  if (performance.clearMeasures === undefined) {
    log("Clear Mearsures: performance.clearMeasures Not supported", 1);
    return;
  }
  log("Clear measures", 1);

  if (typeof obj == "string") {
    log("... cleared '" + obj + "' measure(s)", 1);
    performance.clearMeasures(obj);
  } else {
    // No argument specified so clear all measures
    log("... cleared All measures", 1);
    performance.clearMeasures();
  }
}
</pre>

<h2 id="Interoperability">Interoperability</h2>

<p>As shown in the {{domxref("Performance")}} interface's <a href="/Web/API/Performance#Browser_compatibility">Browser Compatibility</a> table, the <code>User Timing</code> methods are broadly implemented by desktop and mobile browsers (the only exceptions are no support for Desktop Safari and Mobile Safari).</p>

<h2 id="See_Also">See Also</h2>

<ul>
 <li><a href="https://w3c.github.io/user-timing/">User Timing Standard</a>; W3C Editor's Draft</li>
 <li><a href="https://siusin.github.io/perf-timing-primer/">A Primer for Web Performance Timing APIs</a>; Xiaoqian Wu; W3C Editor's Draft</li>
</ul>
